编译安装 mysql 5.5.10 和 php 5.3.6 通过 

就在前两天,mysql 开发团队发布了5.5.x分支的最新稳定版—5.5.10,极大的改善了对多核处理器的负载处理能力,于是便打算升级到此版本。

今天早些时候,php 团队也对外发布了其5.3.x分支的最新版本—5.3.6,考虑到我前段时间用的是5.3.6RC1,故而打算跟进到发布版。

于是今天便动手了,先是mysql.

下载源码包,解压,进入目录
我的编译参数:
[[email protected] mysql-5.5.10]# cmake . \
> -DCMAKE_BUILD_TYPE:STRING=Release \
> -DCMAKE_INSTALL_PREFIX:PATH=/usr/local/mysql \
> -DCMAKE_USE_RELATIVE_PATHS:BOOL=OFF \
> -DCOMMUNITY_BUILD:BOOL=ON \
> -DENABLED_LOCAL_INFILE:BOOL=OFF \
> -DENABLED_PROFILING:BOOL=OFF \
> -DENABLE_DEBUG_SYNC:BOOL=OFF \
> -DINSTALL_BINDIR:STRING=../bin \
> -DINSTALL_DOCDIR:STRING=docs \
> -DINSTALL_DOCREADMEDIR:STRING=docs \
> -DINSTALL_INCLUDEDIR:STRING=include \
> -DINSTALL_INFODIR:STRING=docs \
> -DINSTALL_LAYOUT:STRING=STANDALONE \
> -DINSTALL_LIBDIR:STRING=lib \
> -DINSTALL_MANDIR:STRING=man \
> -DINSTALL_MYSQLSHAREDIR:STRING=share \
> -DINSTALL_SBINDIR:STRING=../sbin \
> -DINSTALL_SCRIPTDIR:STRING=scripts \
> -DINSTALL_SHAREDIR:STRING=share \
> -DINSTALL_SQLBENCHDIR:STRING=sql \
> -DINSTALL_SUPPORTFILESDIR:STRING=support-files \
> -DMYSQL_DATADIR:PATH=/var/run/mysql \
> -DSYSCONFDIR:PATH=/etc/sysconfig/mysql \
> -DWITHOUT_SERVER:BOOL=OFF \
> -DWITH_EMBEDDED_SERVER:BOOL=OFF \
> -DWITH_EXTRA_CHARSETS:STRING=all \
> -DWITH_INNOBASE_STORAGE_ENGINE:BOOL=OFF \
> -DWITH_PARTITION_STORAGE_ENGINE:BOOL=OFF \
> -DWITH_PERFSCHEMA_STORAGE_ENGINE:BOOL=OFF \
> -DWITH_SSL:STRING=no \
> -DWITH_UNIT_TESTS:BOOL=OFF \
> -DWITH_ZLIB:STRING=bundle

没有任何问题,直接make && make install,编译安装.

好了之后,由于我使用了一个小把戏,把相对于 INSTALL_PREFIX 的bin/sbin 目录安装到/usr/local 下去了,所以mysql 根目录下的scripts/mysql_install_db 不能用了。

所以,恢复数据库只能换别的方法。

首先,把备份的my.cnf文件放到 /etc/sysconfig/my.cnf 下。
之后,直接运行mysql_secure_installation,重置root密码,刷新权限表。
这时再登录mysql,数据就都回来了。

注:该方法可能只适用于5.5.x 之间的升级(我是从5.5.9->5.5.10),且要求datadir里面文件都在。

至此,mysql升级完成。接下来是php.

下载源码包,解压,进入目录
[[email protected] php-5.3.6]# ./configure \
> --prefix=/usr/local/php \
> --exec-prefix=/usr/local \
> --sysconfdir=/etc/sysconfig/php \
> --localstatedir=/var \
> --disable-cli \
> --enable-fpm \
> --with-fpm-user=http \
> --with-fpm-group=web \
> --with-config-file-path=/etc/sysconfig/php \
> --with-config-file-scan-dir=/etc/sysconfig/php \
> --disable-ipv6 \
> --with-regex=php \
> --with-pcre-regex \
> --with-zlib \
> --with-bz2 \
> --with-curl \
> --enable-dba \
> --enable-exif \
> --with-gd \
> --with-gettext \
> --with-mhash \
> --enable-mbstring \
> --with-mcrypt \
> --with-mysql=/usr/local/mysql \
> --with-mysql-sock=/tmp/mysql.sock \
> --with-mysqli=/usr/local/bin/mysql_config \
> --disable-pdo \
> --with-libedit \
> --enable-soap \
> --enable-sockets \
> --with-xmlrpc \
> --enable-zip \
> --without-pear \
> --enable-zend-multibyte

检查依赖,报错。找不到 libedit.h 头文件.

yum install libedit-devel

即可.再次检查,通过。make && make install 编译安装.

不一会儿,就搞定了.
恢复下配置文件,php-fpm.conf、php.ini. 便可以启动php-fpm进程。

OK,升级完成.
[ ] ( 1184 次浏览 ) 永久链接 ( 2.9 / 1700 )
利用Live CD重新安装grub至硬盘 

最近把硬盘重新分区了,以前windows 和 linux 各20G的空间明显感觉不够用了(该死的visual studio 和 sql server,擦~),于是便格盘重新划分了下。

windows 就选择了最新的windows 7 with sp1 的ISO,ubuntu 嘛,由于11.04 natty还未发布,故而使用了其最新的测试版 alpha 3。

由于我是先安装的ubuntu(需要用Live CD 自带的分区工具),后安装的windows.导致我之前的硬盘引导被覆盖了,开机直接进windows了。

这个问题我之前曾经处理过一次,不过由于年代久远,忘了具体操作了,反正是重建grub就对了。

于是火速重启,放入ubuntu live CD,光盘启动,进入Live 模式。

我只记得是与"grub"相关的命令,具体是什么记不清了,于是便列出了BIN_PATH下所有的相关命令。
ls /bin | grep grub
ls /sbin | grep grub
……
终于找到了grub-install 和 update-grub 两个利器。

首先安装grub至硬盘,
mount /dev/sda2 ~/tmp #sda2 为linux root 所在分区
grub-install --root-directory=~/tmp /dev/sda2

接下来就是重建grub.cfg了,
update-grub
即可,接下来就会打印出
found linux kernel 2.xx.xx
found windows loader
……
字样,至此,grub安装完毕,再次bs下微软.
[ ] ( 3075 次浏览 ) 永久链接 ( 3 / 1587 )
让 nginx 支持 HTML5 video 源文件 

最近,也就是过年来了这段时间,我忽然对《明天会更好》这首老歌很感兴趣了,于是昨天便在自己的博客里面分享出了这首歌,当然我选择的是以HTML5 方式展现出来.

在此感谢下W3Schools,让我能够快速上手HTML5 的一些标签.

我是在优酷网下载的该MV,flv格式的,不易于分享,于是便转成了更加开放的ogg.
在视频转换方面,我使用的是ffmpeg2theora工具.

ffmpeg2theora -x 400 -y 350 --sync xxx.flv

我把转换好的ogv文件上传到我自己的服务器上,按照w3school上的例子,把相对路径改成了绝对路径,便了事了。我认为不会有什么问题了,也没有去测试能否播放。

直到今早,我打开我的博客,出人意料的是,我的chrome崩溃了。我开始猜到是html5的问题.

果然,视频不能播放,可是下载没有问题。说明不是权限问题。
也不可能是视频编码的问题,因为我昨天在本地测试过了,是可以播放的。

我百思不得其解,谷歌搜索了一下,在这里找到了答案.

原来是服务器的文件类型 MIME-type 在作怪.因为我服务器中的所有静态文件/资源文件都是由nginx在处理的。而nginx 默认的mime-types 里面没有 ogv 类型.

添加即可,加入

video/ogg ogg;
video/ogg ogv;


重启nginx即可.

注:如果ogg文件是视频的,必须为以上内容。参见:https://developer.mozilla.org/En/Media_formats_supported_by_the_audio_and_video_elements#Recognized_MIME.c2.a0types_for_Ogg_media

再测试下,火狐已经可以播放了,不过chrome还是崩溃.
这又是怎么回事? 待解.
[ ] ( 1429 次浏览 ) 永久链接 ( 3 / 1520 )
MySQL 升级后pam-mysql 验证失效的解决办法 

昨天把mysql升级到了5.5.9版本,忽然发现ftp登录不了了……由于我的vsftpd是用pam-mysql验证用户的,怀疑可能是这方面出现了问题.

一一尝试:

1.首先,怀疑是pam-mysql 用来访问vsftpd.users 表的用户ftp 权限不够,

重新授权.
grant all on vsftpd.users to 'ftp'@'localhost' identified by 'XXXX';

flush privileges;
刷新权限表。

尝试ftp登录,还是失败。我用 ftp 身份本地登录mysql,一切正常.看来不是这个问题.

2.怀疑是pam-mysql 口令加密方式有问题。把配置中的crypt=2 改成 明文(0).尝试登录,还是失败。再改回来,用PASSWORD()函数重新设密码,还是失败.

3.难道又是localhost 和 127.0.0.1 的问题?都授权了一下,还是登不进。我擦~

4.不会是pam-mysql不兼容现在的mysql吧?!我倒吸了一口凉气。好在编译安装pam-mysql不是很麻烦,赶紧动手.

下载源码包,解压,进入目录,
./configure --with-mysql=/usr/local/mysql #只要这一句
直接make.

备份之前旧版本的pam-mysql.so 文件.
mv /lib/security/pam_mysql.so /lib/security/pam_mysql.so.old

复制新生成的pam-mysql 模块到 /lib/security 目录下.
cp ./.lib/pam_mysql.so /lib/security/

别忘了重新ld链接下.
ldconfig -v

别的什么也不要改,重启vsftpd.

再次尝试登录ftp,成功了~

我擦,真是pam-mysql 的原因.
[ ] ( 1232 次浏览 ) 永久链接 ( 3 / 1591 )
服务器升级之二 mysql 5.5.9、php 5.3.6RC 编译安装 

接上一篇。

刚搞完前端,就开始折腾后端。主要就是个 php 和 mysql.正好前一段时间的那个php没有版本信息的问题还未解决,今天索性办了.

先mysql,后php。这是惯例.
mysql 5.5.9 http://mirror.services.wisc.edu/mysql/D ... 5.9.tar.gz

下载源码包,解压,进入目录
我的cmake参数:
[[email protected] mysql-5.5.9]# cmake . \
> -DCMAKE_BUILD_TYPE:STRING=Release \
> -DCMAKE_INSTALL_PREFIX:PATH=/usr/local/mysql \
> -DCMAKE_USE_RELATIVE_PATHS:BOOL=OFF \
> -DCOMMUNITY_BUILD:BOOL=ON \
> -DENABLED_PROFILING:BOOL=ON \
> -DENABLE_DEBUG_SYNC:BOOL=OFF \
> -DINSTALL_BINDIR:STRING=bin \
> -DINSTALL_DOCDIR:STRING=docs \
> -DINSTALL_DOCREADMEDIR:STRING=docs \
> -DINSTALL_INCLUDEDIR:STRING=include \
> -DINSTALL_INFODIR:STRING=docs \
> -DINSTALL_LAYOUT:STRING=STANDALONE \
> -DINSTALL_LIBDIR:STRING=lib \
> -DINSTALL_MANDIR:STRING=man \
> -DINSTALL_MYSQLDATADIR:STRING=data \
> -DINSTALL_MYSQLSHAREDIR:STRING=share \
> -DINSTALL_MYSQLTESTDIR:STRING=test \
> -DINSTALL_PLUGINDIR:STRING=lib/plugin \
> -DINSTALL_SBINDIR:STRING=sbin \
> -DINSTALL_SCRIPTDIR:STRING=scripts \
> -DINSTALL_SHAREDIR:STRING=share \
> -DINSTALL_SQLBENCHDIR:STRING=sql \
> -DINSTALL_SUPPORTFILESDIR:STRING=support-files \
> -DMYSQL_DATADIR:PATH=/var/run/mysql/data \
> -DSYSCONFDIR:PATH=/etc/sysconfig/mysql \
> -DWITHOUT_SERVER:BOOL=OFF \
> -DWITH_EMBEDDED_SERVER:BOOL=OFF \
> -DWITH_EXTRA_CHARSETS:STRING=all \
> -DWITH_INNOBASE_STORAGE_ENGINE:BOOL=OFF \
> -DWITH_LIBEDIT:BOOL=ON \
> -DWITH_READLINE:BOOL=OFF \
> -DWITH_SSL:STRING=no \
> -DWITH_UNIT_TESTS:BOOL=OFF \
> -DWITH_ZLIB:STRING=bundled

检查依赖,没有问题.接下来 make && make install.
话说cmake 的 INSTALL_XXXDIR 均使用相对路径,确是很蛋疼.

注:初次编译前最好查看下帮助
[[email protected] mysql-5.5.9]# cmake . -LAH

或者 http://forge.mysql.com/wiki/CMake

安装完成后,将备份的配置文件 my.cnf 复制到 /etc/sysconfig/mysql/ 下.
恢复数据库.先初始化.

运行
[[email protected] bin]# ../scripts/mysql_install_db --basedir=/usr/local/mysql --datadir=/var/run/mysql --user=mysql
重建系统表。

./mysqld_safe & 启动数据库,报错.

[[email protected] ~]# cat /var/run/mysql/PowerPC.err |grep ERROR
110223 6:24:16 [ERROR] Unknown/unsupported storage engine: InnoDB
110223 6:24:16 [ERROR] Aborting
110223 6:25:13 [ERROR] Unknown/unsupported storage engine: InnoDB
110223 6:25:13 [ERROR] Aborting
110223 6:33:18 [ERROR] /usr/local/mysql/bin/mysqld: unknown variable 'innodb_data_home_dir=/var/run/mysql/'
110223 6:33:18 [ERROR] Aborting
110223 6:34:14 [ERROR] /usr/local/mysql/bin/mysqld: unknown variable 'innodb_buffer_pool_size=10M'
110223 6:34:14 [ERROR] Aborting


原来是innodb 的原因,由于mysql 5.5.x 默认启用innodb,而我这次的版本又没有把它编译进来。故而报错.

解决办法:删掉/注释掉配置文件里关于 innodb的部分,并加入
default-storage-engine          = MyISAM

即可.

再次启动mysql,正常.

导入之前备份出去的sql文件,
mysql -u root -p < xxx.sql
刷新权限表即可.

mysql 安装完成.

接下来是php.
php 5.3.6rc1 http://downloads.php.net/johannes/php-5.3.6RC1.tar.bz2

这次选择的是最新的rc版.解压,进入目录
我的configure:
[[email protected] php-5.3.6RC1]# ./configure \
> --prefix=/usr/local/php \
> --exec-prefix=/usr/local \
> --sysconfdir=/etc/sysconfig/php \
> --localstatedir=/var/run \
> --disable-cli \
> --enable-fpm \
> --with-fpm-user=http \
> --with-fpm-group=web \
> --with-config-file-path=/etc/sysconfig/php \
> --disable-ipv6 \
> --with-zlib \
> --with-bz2 \
> --with-curl \
> --enable-exif \
> --with-gd \
> --with-mhash \
> --enable-mbstring \
> --with-mcrypt \
> --with-mysql=/usr/local/mysql \
> --with-mysql-sock=/tmp \
> --with-mysqli=/usr/local/mysql/bin/mysql_config \
> --with-xmlrpc \
> --enable-zip \
> --without-pear

检查依赖,一切OK。然后就 make && make install.
一段时间后,php 也搞定了.再把备份的配置文件恢复一下。由于eAccelerator 插件与之前的老版本php一起被删掉了,故而在php.ini 里先注释掉其部分。

一切都做好后,服务器升级便结束了.
[ ] ( 1208 次浏览 ) 永久链接 ( 3 / 1405 )

<< <上一页 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 | 下一页> >>